package run.evan.cellularprovip;

import android.app.Application;
import android.content.Context;

import de.robv.android.xposed.IXposedHookLoadPackage;
import de.robv.android.xposed.XC_MethodHook;
import de.robv.android.xposed.XC_MethodReplacement;
import de.robv.android.xposed.XposedBridge;
import de.robv.android.xposed.XposedHelpers;
import de.robv.android.xposed.callbacks.XC_LoadPackage;

public class MainHook implements IXposedHookLoadPackage {
    @Override
    public void handleLoadPackage(XC_LoadPackage.LoadPackageParam loadPackageParam) throws Throwable {
        if (loadPackageParam.packageName.contains("make.more.r2d2.cellular_pro")) {
            XposedBridge.log("Cellular-Pro Xposed init");
            XposedHelpers.findAndHookMethod("com.qihoo.util.a", loadPackageParam.classLoader, "a", Context.class, new XC_MethodHook() {
                @Override
                protected void afterHookedMethod(MethodHookParam param) throws Throwable {
                    super.afterHookedMethod(param);
                    Context context = (Context) param.args[0];
                    ClassLoader classLoader = context.getClassLoader();
                    Class assistUtilClass = XposedHelpers.findClass("make.more.r2d2.cellular_pro.help.AssistUtil", classLoader);

                    XposedHelpers.findAndHookMethod(assistUtilClass, "h0", new XC_MethodHook() {
                        @Override
                        protected void afterHookedMethod(MethodHookParam param) throws Throwable {
                            super.afterHookedMethod(param);
                            param.setResult(true);
                        }
                    });
                    XposedHelpers.findAndHookMethod(assistUtilClass, "w0", new XC_MethodHook() {
                        @Override
                        protected void afterHookedMethod(MethodHookParam param) throws Throwable {
                            super.afterHookedMethod(param);
                            param.setResult(true);
                        }
                    });

                    XposedHelpers.findAndHookMethod(assistUtilClass, "C0", new XC_MethodHook() {
                        @Override
                        protected void afterHookedMethod(MethodHookParam param) throws Throwable {
                            super.afterHookedMethod(param);
                            param.setResult(true);
                        }
                    });


                    XposedHelpers.findAndHookMethod(assistUtilClass, "k1", new XC_MethodReplacement() {
                        @Override
                        protected Object replaceHookedMethod(MethodHookParam methodHookParam) throws Throwable {
                            XposedHelpers.setStaticObjectField(assistUtilClass, "w", "setAllowedNetworkTypesForReason");
                            return "setAllowedNetworkTypesForReason";
                        }
                    });


                    XposedHelpers.findAndHookMethod("make.more.r2d2.cellular_pro.bean.l", classLoader, "o", new XC_MethodReplacement() {
                        @Override
                        protected Object replaceHookedMethod(MethodHookParam methodHookParam) throws Throwable {
                            return "s";
                        }
                    });

                    XposedHelpers.findAndHookMethod("make.more.r2d2.cellular_pro.bean.l", classLoader, "a", android.content.SharedPreferences.class, new XC_MethodReplacement() {
                        @Override
                        protected Object replaceHookedMethod(MethodHookParam methodHookParam) throws Throwable {
                            return "0006707e-dd4c-45a7-79bf-8d0fe4722eb0";
                        }
                    });

                    XposedHelpers.findAndHookMethod("make.more.r2d2.cellular_pro.bean.l", classLoader, "b", new XC_MethodReplacement() {
                        @Override
                        protected Object replaceHookedMethod(MethodHookParam methodHookParam) throws Throwable {
                            return "0006707e-dd4c-45a7-79bf-8d0fe4722eb0";
                        }
                    });


                    XposedHelpers.findAndHookMethod("make.more.r2d2.cellular_pro.trace.TraceController", classLoader, "z", new XC_MethodReplacement() {
                        @Override
                        protected Object replaceHookedMethod(MethodHookParam methodHookParam) throws Throwable {
                            return null;
                        }
                    });

                    XposedHelpers.findAndHookMethod("make.more.r2d2.cellular_pro.trace.TraceController", classLoader, "y", new XC_MethodReplacement() {
                        @Override
                        protected Object replaceHookedMethod(MethodHookParam methodHookParam) throws Throwable {
                            return null;
                        }
                    });

                    XposedHelpers.findAndHookMethod("make.more.r2d2.cellular_pro.bean.l", classLoader, "i", new XC_MethodReplacement() {
                        @Override
                        protected Object replaceHookedMethod(MethodHookParam methodHookParam) throws Throwable {
                            return "2099-12-31";
                        }
                    });


                }
            });


        }
    }
}
